//+------------------------------------------------------------------+
//|                                                      test.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
 

input double           	iPoints=70;         		// Stop and Profit points


string ORDER_TYPE_to_string(ENUM_ORDER_TYPE ot)
{
    switch(ot)
    {
        case ORDER_TYPE_BUY: return "BUY";    
        case ORDER_TYPE_SELL: return "SELL";    
        case ORDER_TYPE_BUY_LIMIT: return "BUY LMT";    
        case ORDER_TYPE_SELL_LIMIT: return "SELL LMT";    
        case ORDER_TYPE_BUY_STOP: return "BUY STP";    
        case ORDER_TYPE_SELL_STOP: return "SELL STP";    
        case ORDER_TYPE_BUY_STOP_LIMIT : return "BUY STPLMT";   
        case ORDER_TYPE_SELL_STOP_LIMIT: return "SELL STPLMT";
        default: break;
   }
   return "unknown ordertype";
}

bool ot_pending_is_buy(ENUM_ORDER_TYPE ot)
{
    switch(ot)
    {
        case ORDER_TYPE_BUY: return true;    
        case ORDER_TYPE_BUY_LIMIT: return true;    
        case ORDER_TYPE_BUY_STOP: return true;     
        case ORDER_TYPE_BUY_STOP_LIMIT : return true;    
        default: break;
   }
   return false;
}
string TRADE_REQUEST_ACTIONS_to_string(ENUM_TRADE_REQUEST_ACTIONS ta)
{
    switch(ta)
    {
        case TRADE_ACTION_DEAL:  return "TRADE_ACTION_DEAL";
        case TRADE_ACTION_PENDING:  return "TRADE_ACTION_PENDING";
        case TRADE_ACTION_SLTP:  return "TRADE_ACTION_SLTP";
        case TRADE_ACTION_MODIFY:  return "TRADE_ACTION_MODIFY";
        case TRADE_ACTION_REMOVE:  return "TRADE_ACTION_REMOVE";
        default: break;
    }
    return "TRADE_ACTION_UNKNOWN";
}
string ORDER_TYPE_FILLING_to_string(ENUM_ORDER_TYPE_FILLING x)
{
    switch(x)
    {
        case ORDER_FILLING_FOK:  return "ORDER_FILLING_FOK";
        case ORDER_FILLING_IOC:  return "ORDER_FILLING_IOC";
        case ORDER_FILLING_RETURN:  return "ORDER_FILLING_RETURN";
        default: break;
    }
    return "TYPE_FILLING_UNKNOWN";
}

string DEAL_ENTRY_to_string(ENUM_DEAL_ENTRY de)
{
    switch(de)
    {
        case DEAL_ENTRY_IN: return "DEAL_ENTRY_IN";
        case DEAL_ENTRY_OUT: return "DEAL_ENTRY_OUT";
        case DEAL_ENTRY_INOUT: return "DEAL_ENTRY_INOUT";
        case DEAL_ENTRY_STATE: return "DEAL_ENTRY_STATE";
        default: break;
    }
    return "DEAL_ENTRY_UNKNOWN";
}
string DEAL_ENTRY_to_string_short(ENUM_DEAL_ENTRY de)
{
    switch(de)
    {
        case DEAL_ENTRY_IN: return "IN";
        case DEAL_ENTRY_OUT: return "OUT";
        case DEAL_ENTRY_INOUT: return "INOUT";
        case DEAL_ENTRY_STATE: return "STATE";
        default: break;
    }
    return "UNKNOWN";
}
string DEAL_TYPE_to_string(ENUM_DEAL_TYPE de)
{
    switch(de)
    {
        case DEAL_TYPE_BUY: return "DEAL_TYPE_BUY";
        case DEAL_TYPE_SELL: return "DEAL_TYPE_SELL";
        case DEAL_TYPE_BALANCE: return "DEAL_TYPE_BALANCE";
        case DEAL_TYPE_CREDIT: return "DEAL_TYPE_CREDIT";
        
        case DEAL_TYPE_CHARGE: return "DEAL_TYPE_CHARGE";
        case DEAL_TYPE_CORRECTION: return "DEAL_TYPE_CORRECTION";
        case DEAL_TYPE_BONUS: return "DEAL_TYPE_BONUS";
        case DEAL_TYPE_COMMISSION: return "DEAL_TYPE_COMMISSION";
        case DEAL_TYPE_COMMISSION_DAILY: return "DEAL_TYPE_COMMISSION_DAILY";
        case DEAL_TYPE_COMMISSION_MONTHLY: return "DEAL_TYPE_COMMISSION_MONTHLY";
        case DEAL_TYPE_COMMISSION_AGENT_DAILY: return "DEAL_TYPE_COMMISSION_AGENT_DAILY";
        case DEAL_TYPE_COMMISSION_AGENT_MONTHLY: return "DEAL_TYPE_COMMISSION_AGENT_MONTHLY";
        case DEAL_TYPE_INTEREST: return "DEAL_TYPE_INTEREST";
        case DEAL_TYPE_BUY_CANCELED: return "DEAL_TYPE_BUY_CANCELED";
        case DEAL_TYPE_SELL_CANCELED: return "DEAL_TYPE_SELL_CANCELED";
        default: break;
    }
    return "DEAL_TYPE_UNKNOWN";
}
 
string DEAL_TYPE_to_string_short(ENUM_DEAL_TYPE de)
{
    switch(de)
    {
        case DEAL_TYPE_BUY: return "BUY";
        case DEAL_TYPE_SELL: return "SELL";
        case DEAL_TYPE_BALANCE: return "BALANCE";
        case DEAL_TYPE_CREDIT: return "CREDIT";
        
        case DEAL_TYPE_CHARGE: return "CHARGE";
        case DEAL_TYPE_CORRECTION: return "CORRECTION";
        case DEAL_TYPE_BONUS: return "BONUS";
        case DEAL_TYPE_COMMISSION: return "COMMISSION";
        case DEAL_TYPE_COMMISSION_DAILY: return "COMMISSION_DAILY";
        case DEAL_TYPE_COMMISSION_MONTHLY: return "COMMISSION_MONTHLY";
        case DEAL_TYPE_COMMISSION_AGENT_DAILY: return "COMMISSION_AGENT_DAILY";
        case DEAL_TYPE_COMMISSION_AGENT_MONTHLY: return "COMMISSION_AGENT_MONTHLY";
        case DEAL_TYPE_INTEREST: return "INTEREST";
        case DEAL_TYPE_BUY_CANCELED: return "BUY_CANCELED";
        case DEAL_TYPE_SELL_CANCELED: return "SELL_CANCELED";
        default: break;
    }
    return "UNKNOWN";
}
string ENUM_TRADE_TRANSACTION_TYPE_to_string_short(ENUM_TRADE_TRANSACTION_TYPE de)
{
    switch(de)
    {
        case TRADE_TRANSACTION_ORDER_ADD: return "ORDER_ADD";
        case TRADE_TRANSACTION_ORDER_UPDATE: return "ORDER_UPDATE";
        case TRADE_TRANSACTION_ORDER_DELETE: return "ORDER_DELETE";
        case TRADE_TRANSACTION_DEAL_ADD: return "DEAL_ADD";
        
        case TRADE_TRANSACTION_DEAL_UPDATE: return "DEAL_UPDATE";
        case TRADE_TRANSACTION_DEAL_DELETE: return "DEAL_DELETE";
        case TRADE_TRANSACTION_HISTORY_ADD: return "HISTORY_ADD";
        case TRADE_TRANSACTION_HISTORY_UPDATE: return "HISTORY_UPDATE";
        case TRADE_TRANSACTION_HISTORY_DELETE: return "HISTORY_DELETE";
        case TRADE_TRANSACTION_POSITION: return "POSITION";
        case TRADE_TRANSACTION_REQUEST: return "REQUEST";
        default: break;
    }
    return "UNKNOWN";
}

string dump_MqlTradeTransaction(const MqlTradeTransaction& t)
{
    //CDealInfo deal;
    //deal.Ticket(t.deal);
   if(t.deal > 0)
      HistoryDealSelect(t.deal);
   string msg=StringFormat("symbol=%s price=%.7f volume=%.2f sl=%.7f tp=%.7f order=%d deal=%d entry-type=%s trans-type=%s order_type=%s deal_type=%s type_time=%d expiration=%s price_trigger=%.7f profit=%.2f"
                           
                           ,t.symbol
                           ,t.price
                           ,t.volume                           
                           ,t.price_sl
                           ,t.price_tp
                           ,t.order
                           ,t.deal           
						   ,DEAL_ENTRY_to_string_short((ENUM_DEAL_ENTRY)HistoryDealGetInteger(t.deal,DEAL_ENTRY))                                          
                           ,ENUM_TRADE_TRANSACTION_TYPE_to_string_short((ENUM_TRADE_TRANSACTION_TYPE) t.type)
                           ,ORDER_TYPE_to_string(t.order_type)
                           ,DEAL_TYPE_to_string(t.deal_type)
                           ,t.time_type
                           ,TimeToString(t.time_expiration)                           
                           ,t.price_trigger
                           ,HistoryDealGetDouble(t.deal,DEAL_PROFIT)
                           );
                        
    return msg;
}
bool	pos_open(void)
{
	CPositionInfo info;
	if(info.Select(Symbol()) == true && info.Volume() > 0)
	{
		return true;
	}
	return false;;
}

bool __go_long=false;

bool open_pos(void)
{
	if(pos_open() == true)
		return false;

	__go_long = !__go_long;

	double price=0.0;
	double stop=0.0;
	double target=0.0;

	CSymbolInfo sinfo;
	sinfo.Name(Symbol());
	sinfo.RefreshRates();

	CTrade trade;
	if(__go_long == true)
	{
		price=sinfo.Ask();
		target=(sinfo.Ask() + iPoints * sinfo.Point());
		stop=(sinfo.Ask() - iPoints * sinfo.Point());

		return trade.Buy(0.01,Symbol(),price,stop,target,"");

	}
	else
	{
		price=sinfo.Ask();
		target=(sinfo.Ask() - iPoints * sinfo.Point());
		stop=(sinfo.Ask() + iPoints * sinfo.Point());

		return trade.Sell(0.01,Symbol(),price,stop,target,"");
	}
	return false;
}
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+


int OnInit()
{
	

    return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
    
  
    
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
	open_pos();
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
}
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction& trans,
                        const MqlTradeRequest& request,
                        const MqlTradeResult& result)
  {
 
 	Print("trans=",dump_MqlTradeTransaction(trans));
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

      
  }


